﻿using System;
using System.Collections.Generic;

namespace scoutmode
{
	public class SceneScoutScreenManager : WfScreenManager
	{
		public ADVKagManager advKag
		{
			get
			{
				return GameMain.Instance.ScriptMgr.adv_kag;
			}
		}

		public WfScreenMoveChildren moveScreen { get; private set; }

		public override void Start()
		{
			base.Start();
			this.moveScreen = base.children_dic["Move"].GetComponent<WfScreenMoveChildren>();
			string empty = string.Empty;
			string empty2 = string.Empty;
			if (this.advKag.tag_backup != null && this.advKag.tag_backup.Count > 0)
			{
				this.backupTag = new Dictionary<string, string>(this.advKag.tag_backup);
				NDebug.Assert(this.advKag.tag_backup.ContainsKey("name") && this.advKag.tag_backup["name"].ToLower() == "SceneScout".ToLower(), "シーン名SceneScoutの名前が不正です");
				NDebug.Assert(this.advKag.tag_backup.ContainsKey("label"), "SceneCallにlabelの設定がされていませんでした");
				NDebug.Assert(this.advKag.tag_backup.ContainsKey("start_label"), "SceneCallにstart_labelの設定がされていませんでした");
				NDebug.Assert(this.advKag.tag_backup.ContainsKey("add_label"), "SceneCallにadd_labelの設定がされていませんでした");
				ScoutMainScreenManager component = base.children_dic["Main"].GetComponent<ScoutMainScreenManager>();
				if (this.advKag.tag_backup.ContainsKey("create_return"))
				{
					component.OnAddedScoutMaidReturned();
				}
				this.CallScreen("Main");
				return;
			}
			this.advKag.LoadScriptFile("debug_scourt.ks", "*シーンコール");
			this.advKag.kag.Exec();
		}

		public void CallAddScoutCharacter(WfScreenChildren finishScreen)
		{
			this.moveScreen.SetNextLabel(this.backupTag["add_label"]);
			finishScreen.Finish();
		}

		public void CallStart(WfScreenChildren finishScreen)
		{
			this.moveScreen.SetNextLabel(this.backupTag["start_label"]);
			finishScreen.Finish();
		}

		public void CallExist(WfScreenChildren finishScreen)
		{
			this.moveScreen.SetNextLabel(this.backupTag["label"]);
			finishScreen.Finish();
		}

		protected override void SettingChildrenList(Dictionary<string, WfScreenChildren> childrenDic)
		{
			foreach (string text in new string[]
			{
				"Main",
				"Move"
			})
			{
				WfScreenChildren component = UTY.GetChildObject(base.gameObject, text, false).GetComponent<WfScreenChildren>();
				component.parent_mgr = this;
				childrenDic.Add(text, component);
			}
		}

		public Dictionary<string, string> backupTag = new Dictionary<string, string>();
	}
}
