﻿using System;
using I2.Loc;
using MaidStatus;
using UnityEngine;
using wf;

namespace scoutmode
{
	public class ScoutStatusPanel : MonoBehaviour
	{
		public bool visible
		{
			get
			{
				return base.gameObject.activeSelf;
			}
			set
			{
				base.gameObject.SetActive(value);
			}
		}

		public void SetDrawStatus(ScoutMaidData scoutMaid)
		{
			if (scoutMaid == null)
			{
				return;
			}
			ScoutMaidData.SimpleStatus status = scoutMaid.status;
			if (this.charaThumbnailSprite.sprite2D != null)
			{
				UnityEngine.Object.Destroy(this.charaThumbnailSprite.sprite2D.texture);
			}
			byte[] iconImageBinary = scoutMaid.iconImageBinary;
			if (iconImageBinary != null)
			{
				Texture2D texture2D = new Texture2D(1, 1, TextureFormat.ARGB32, false);
				texture2D.LoadImage(iconImageBinary);
				this.charaThumbnailSprite.sprite2D = Sprite.Create(texture2D, new Rect(0f, 0f, (float)texture2D.width, (float)texture2D.height), default(Vector2));
				this.charaThumbnailSprite.SetDimensions(this.charaThumbnailSprite.sprite2D.texture.width, this.charaThumbnailSprite.sprite2D.texture.height);
			}
			this.charaName1.text = status.name1;
			this.charaName2.text = status.name2;
			this.heroineType.GetComponent<UILabel>().text = status.personal.drawName;
			Utility.SetLocalizeTerm(this.heroineType, status.personal.termName, false);
			this.seikeiken.GetComponent<UILabel>().text = EnumConvert.GetString(status.seikeiken);
			Utility.SetLocalizeTerm(this.seikeiken, EnumConvert.GetTerm(status.seikeiken), false);
			this.height.text = status.height.ToString();
			this.weight.text = status.weight.ToString();
			this.bust.text = status.bust.ToString();
			this.cup.text = status.cup;
			this.waist.text = status.waist.ToString();
			this.hip.text = status.hip.ToString();
			this.lovely.text = status.lovely.ToString();
			this.elegance.text = status.elegance.ToString();
			this.charm.text = status.charm.ToString();
			this.care.text = status.care.ToString();
			this.reception.text = status.reception.ToString();
			this.cooking.text = status.cooking.ToString();
			this.dance.text = status.dance.ToString();
			this.vocal.text = status.vocal.ToString();
			this.teachRate.text = ((int)System.Math.Floor((double)status.teachRate / 10.0)).ToString();
			this.studyRate.text = ((int)System.Math.Floor((double)status.studyRate / 10.0)).ToString();
			this.inyoku.text = status.inyoku.ToString();
			this.mValue.text = status.mvalue.ToString();
			this.hentai.text = status.hentai.ToString();
			this.housi.text = status.housi.ToString();
			this.yotogiPlayCount.text = status.playCountYotogi.ToString();
		}

		[SerializeField]
		private UI2DSprite charaThumbnailSprite;

		[SerializeField]
		private UILabel charaName1;

		[SerializeField]
		private UILabel charaName2;

		[SerializeField]
		private Localize heroineType;

		[SerializeField]
		private Localize seikeiken;

		[SerializeField]
		private UILabel height;

		[SerializeField]
		private UILabel weight;

		[SerializeField]
		private UILabel bust;

		[SerializeField]
		private UILabel cup;

		[SerializeField]
		private UILabel waist;

		[SerializeField]
		private UILabel hip;

		[SerializeField]
		private UILabel lovely;

		[SerializeField]
		private UILabel elegance;

		[SerializeField]
		private UILabel charm;

		[SerializeField]
		private UILabel care;

		[SerializeField]
		private UILabel reception;

		[SerializeField]
		private UILabel cooking;

		[SerializeField]
		private UILabel dance;

		[SerializeField]
		private UILabel vocal;

		[SerializeField]
		private UILabel teachRate;

		[SerializeField]
		private UILabel studyRate;

		[SerializeField]
		private UILabel inyoku;

		[SerializeField]
		private UILabel mValue;

		[SerializeField]
		private UILabel hentai;

		[SerializeField]
		private UILabel housi;

		[SerializeField]
		private UILabel yotogiPlayCount;
	}
}
